'' Debug_Lcd Test (4x20 LCD)
''
'' Author.... Jon Williams
'' Updated... 29 APR 2006
''
'' Uses the Parallax 4x20 serial LCD to display a counter in decimal, hex, and binary formats.


CON

  _clkmode = xtal1 + pll16x                             ' use crystal x 16
  _xinfreq = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)

  LCD_PIN   = 0                                         ' for Parallax 4x20 serial LCD on P0
  LCD_BAUD  = 19_200
  LCD_LINES = 4    


OBJ

  lcd : "debug_lcd"


PUB main | idx

  if lcd.start(LCD_PIN, LCD_BAUD, LCD_LINES)            ' start lcd
    lcd.cursor(0)                                       ' cursor off
    lcd.backLight(true)                                 ' backlight on (if available)
    lcd.custom(0, @Bullet)                              ' create custom character 0
    lcd.cls                                             ' clear the lcd
    lcd.str(string("LCD DEBUG", 13))
    lcd.putc(0)                                         ' display custom bullet character
    lcd.str(string(" Dec", 13))
    lcd.putc(0)
    lcd.str(string(" Hex", 13)) 
    lcd.putc(0)
    lcd.str(string(" Bin"))     

    repeat
      repeat idx from 0 to 255
        updateLcd(idx)
        waitcnt(clkfreq / 5 + cnt)                      ' pad with 1/5 sec

      repeat idx from -255 to 0
        updatelcd(idx)
        waitcnt(clkfreq / 5 + cnt)
        

PRI updateLcd(value)

  lcd.gotoxy(12, 1)
  lcd.decf(value, 8)                                    ' print right-justified decimal value
  lcd.gotoxy(11, 2)
  lcd.ihex(value, 8)                                    ' print indicated (with $) hex
  lcd.gotoxy(7, 3)
  lcd.ibin(value, 12)                                   ' print indicated (with %) binary                
                
      
DAT

  Bullet      byte      $00, $04, $0E, $1F, $0E, $04, $00, $00

 